clear all

Dll4_ext = 0; %Fitted value of the external DLL4 coating
Fmin_to_be_tip = 20;
ncells=10;
lambda = 0.1; Yap0 = 0.47; nn = 6.5;
lll=1;
nrrpts = 25;%Amount of repeats
eff_lfng= 0; %1 = effect of YAP/TAZ on Lfng, 0 = No effect of YAP/TAZ on Lfng

loopvar = lll; %Define through which variable you want to loop
stiffnesrange= [0.5 1.5 2.5 3.7 4.7 5.6 6.6 7.6 8.7 9.8 11.2 12.7 14.6 17 20.1 24.2 30 38.5 52.6 70 79.5 143 380 400];%1:0.5:100;% [ 5 15 20 25 30 60];%[1 5 15 20 25 30 60];%1:4:50;%[0.5 1.5 70 400];%1:100;%0:2:100;%1:100;

%pre-allocation of vectors
all_fak = zeros(length(loopvar),length(stiffnesrange));
all_RhoA = zeros(length(loopvar),length(stiffnesrange));
all_Rock = zeros(length(loopvar),length(stiffnesrange));
all_mDia = zeros(length(loopvar),length(stiffnesrange));
all_Myo = zeros(length(loopvar),length(stiffnesrange));
all_Limk = zeros(length(loopvar),length(stiffnesrange));
all_Cofilin = zeros(length(loopvar),length(stiffnesrange));
all_Fcyto = zeros(length(loopvar),length(stiffnesrange));
all_Yaptaz = zeros(length(loopvar),length(stiffnesrange));
all_mal = zeros(length(loopvar),length(stiffnesrange));
Fstress = zeros(length(loopvar),length(stiffnesrange));
all_VR = zeros(length(loopvar),length(stiffnesrange));
all_v_VR = zeros(length(loopvar),length(stiffnesrange));
all_DL = zeros(length(loopvar),length(stiffnesrange));
all_DR = zeros(length(loopvar),length(stiffnesrange));
all_NL = zeros(length(loopvar),length(stiffnesrange));
all_NR = zeros(length(loopvar),length(stiffnesrange));
all_D_NL = zeros(length(loopvar),length(stiffnesrange));
all_D_NR = zeros(length(loopvar),length(stiffnesrange));
all_I = zeros(length(loopvar),length(stiffnesrange));
all_HE = zeros(length(loopvar),length(stiffnesrange));
all_F = zeros(length(loopvar),length(stiffnesrange));
V = zeros(length(loopvar),length(stiffnesrange));
DGG = zeros(length(loopvar),length(stiffnesrange));
HH = zeros(length(loopvar),length(stiffnesrange));
all_D_N_ext = zeros(length(loopvar),length(stiffnesrange));
all_tip = zeros(length(loopvar),length(stiffnesrange));
tiptime=zeros(length(loopvar),length(stiffnesrange));
all_Lfng = zeros(length(loopvar),length(stiffnesrange));

for i = 1:length(loopvar)
    
    LD=1;
    E=1;
    c=7.5; 
    lambda = 0.1;%0.1;%Set lambda = 1 if you want to switch off the YAP/TAZ - DLL4 inhibitory interaction
    ncombs=10;
    threshold_rock_s=0.1;
    smoothing_range_s=0.2;
    
    %Initial/total values for all used proteins
    Fak_total_s= 1;
    RhoA_total_s=1;
    Rock_total_s=1;
    mDia_total_s= 1;
    Myo_total_s= 1;
    Limk_total_s=1;
    Cofilin_total_s=1;
    Fcyto_total_s=1;
    Yaptaz_total_s=1;
    mal_total_s=1;
    Fstrtot=1;
    y_parameter_s=500;

    Fak0=rand(1,ncells)*0;
    RhoA0=rand(1,ncells)*0;
    Rock0=rand(1,ncells)*0;
    mDia0=rand(1,ncells)*0;
    Myo0=rand(1,ncells)*0;
    Limk0=rand(1,ncells)*0;
    Cofilin0=rand(1,ncells)*0;
    Fcyto0=rand(1,ncells)*0;
    Yaptaz0=rand(1,ncells)*0;
    mal0=rand(1,ncells)*0;
    Fstr0=rand(1,ncells)*0;
    
    %Starting values for VEGF model
    VR0(1,1:ncells)= ones(1,ncells)*0.000000; %random value of VR initially expressed by cells
    v_VR0(1,1:ncells)= rand(1,ncells)*0.000000; %random value of VEGF-VEGFR initially expressed by cells
    DL0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of Delta initially expressed by cells
    DR0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of Delta initially expressed by cells
    NL0(1,1:ncells)= ones(1,ncells)*0.0000000; %value of Notch initially expressed by cells
    NR0(1,1:ncells)= ones(1,ncells)*0.0000000; %value of Notch initially expressed by cells
    D_NL0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of bound Delta_Notch initially present in cells
    D_NR0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of bound Delta_Notch initially present in cells
    I0(1,1:ncells)= rand(1,ncells)*0.00000000; %random value of NICD initially present in cells;
    HE0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of HES+HEY+HER initially expressed by cells;
    F0(1,1:ncells)= rand(1,ncells)*0.0000000; %value of filopodia initially present in cells;   
    Dext_NL0 = rand(1,ncells)*0.000000; %random value of bound Delta(ext)_Notch initially present in cells
    Dext_NR0 = rand(1,ncells)*0.000000; %random value of bound Delta(ext)_Notch initially present in cells
    
    prods = Dll4_ext;
    
    x=1;
    j=0;
    
    %Pre-allocation of vectors
    all_fak2 = zeros(nrrpts,length(stiffnesrange));
    all_RhoA2 = zeros(nrrpts,length(stiffnesrange));
    all_Rock2 = zeros(nrrpts,length(stiffnesrange));
    all_mDia2 = zeros(nrrpts,length(stiffnesrange));
    all_Myo2 = zeros(nrrpts,length(stiffnesrange));
    all_Limk2 = zeros(nrrpts,length(stiffnesrange));
    all_Cofilin2 = zeros(nrrpts,length(stiffnesrange));
    all_Fcyto2 = zeros(nrrpts,length(stiffnesrange));
    all_Yaptaz2 = zeros(nrrpts,length(stiffnesrange));
    all_mal2 = zeros(nrrpts,length(stiffnesrange));
    Fstress2 = zeros(nrrpts,length(stiffnesrange));
    all_VR2 = zeros(nrrpts,length(stiffnesrange));
    all_v_VR2 = zeros(nrrpts,length(stiffnesrange));
    all_DL2 = zeros(nrrpts,length(stiffnesrange));
    all_DR2 = zeros(nrrpts,length(stiffnesrange));
    all_NL2 = zeros(nrrpts,length(stiffnesrange));
    all_NR2 = zeros(nrrpts,length(stiffnesrange));
    all_D_NL2 = zeros(nrrpts,length(stiffnesrange));
    all_D_NR2 = zeros(nrrpts,length(stiffnesrange));
    all_I2 = zeros(nrrpts,length(stiffnesrange));
    all_HE2 = zeros(nrrpts,length(stiffnesrange));
    all_F2 = zeros(nrrpts,length(stiffnesrange));
    V2 = zeros(nrrpts,length(stiffnesrange));
    DGG2 = zeros(nrrpts,length(stiffnesrange));
    HH2 = zeros(nrrpts,length(stiffnesrange));
    all_D_N_ext2 = zeros(nrrpts,length(stiffnesrange));
    all_tip2 = zeros(nrrpts,length(stiffnesrange));
    tiptime2=zeros(nrrpts,length(stiffnesrange));
    tiptime3=zeros(nrrpts,length(stiffnesrange));
    all_Lfng2=zeros(nrrpts,length(stiffnesrange));
    
        for k =1:nrrpts
            k
            rng('shuffle')
            options=odeset('Reltol',1e-12,'AbsTol',1e-6, 'MaxStep', 100);
            VEGF_ext = 0.0300000/10; %Smaller VEGF concentration to account for its presence in FBS
            
             %Define the input here, to take the variability of it into account and average over it by the repeats
             input=[threshold_rock_s;smoothing_range_s;Fak_total_s;RhoA_total_s;Rock_total_s;mDia_total_s;Myo_total_s;Limk_total_s;Cofilin_total_s;Fcyto_total_s;LD;E;y_parameter_s;c;Yaptaz_total_s;mal_total_s];
             V0(1,1:ncells) = ones(1,ncells)*0.0000000 +rand(1,ncells)*10^(-8);% value of V initially seen by cells
             y0=[Fak0,RhoA0,Rock0,mDia0,Myo0,Limk0,Cofilin0,Fcyto0,Yaptaz0,mal0,Fstr0, VR0,v_VR0,DL0,DR0,NL0,NR0,D_NL0,D_NR0,I0,HE0,F0,Dext_NL0,Dext_NR0];
            
            for EE=1:length(stiffnesrange)
                E = stiffnesrange(EE);
                j=j+1;
                input(12)=E;
                %Simulate 86400 seconds, or 24 hours
                [t,y]=ode15s(@differentationequations_LF,[0 86400],y0,options,input,ncells,VEGF_ext,V0',lambda,nn,Yap0,prods,eff_lfng);
                %I need to rearrange the output
                all_fak2(k,EE)=mean(y(end,1:ncells));
                all_RhoA2(k,EE)=mean(y(end,ncells+1:2*ncells));
                all_Rock2(k,EE)=mean(y(end,2*ncells+1:3*ncells));
                all_mDia2(k,EE)=mean(y(end,3*ncells+1:4*ncells));
                all_Myo2(k,EE)=mean(y(end,4*ncells+1:5*ncells));
                all_Limk2(k,EE)=mean(y(end,5*ncells+1:6*ncells));
                all_Cofilin2(k,EE)=mean(y(end,6*ncells+1:7*ncells));
                all_Fcyto2(k,EE)=mean(y(end,7*ncells+1:8*ncells));
                all_Yaptaz2(k,EE)=mean(y(end,8*ncells+1:9*ncells));
                all_mal2(k,EE)=mean(y(end,9*ncells+1:10*ncells));
                Fstress2(k,EE)=mean(y(end,7*ncells+1:8*ncells).*y(end,4*ncells+1:5*ncells));
                all_VR2(k,EE)=mean(y(end,11*ncells+1:12*ncells));
                all_v_VR2(k,EE)=mean(y(end,12*ncells+1:13*ncells));
                all_DL2(k,EE)=mean(y(end,13*ncells+1:14*ncells));
                all_DR2(k,EE)=mean(y(end,14*ncells+1:15*ncells));
                all_NL2(k,EE)=mean(y(end,15*ncells+1:16*ncells));
                all_NR2(k,EE)=mean(y(end,16*ncells+1:17*ncells));
                all_D_NL2(k,EE)=mean(y(end,17*ncells+1:18*ncells));
                all_D_NR2(k,EE)=mean(y(end,18*ncells+1:19*ncells));
                all_I2(k,EE)=mean(y(end,19*ncells+1:20*ncells));
                all_HE2(k,EE)=mean(y(end,20*ncells+1:21*ncells));
                all_F2(k,EE)=mean(y(end,21*ncells+1:22*ncells));
                all_D_N_ext2(k,EE)= mean(y(end,22*ncells+1:23*ncells)+y(end,23*ncells+1:24*ncells));
                V2(k,EE)=mean(V0+0.001.*V0.*y(end,21*ncells+1:22*ncells).^2); 
                DGG2(k,EE)=mean(((0.001 + 0.1*y(end,12*ncells+1:13*ncells).^2./(1+y(end,12*ncells+1:13*ncells).^2))/2).*(lambda+((1-lambda)./((1+(y(end,8*ncells+1:9*ncells))./Yap0).^nn))));
                HH2(k,EE)=mean(((0.001 + 0.1*y(end,19*ncells+1:20*ncells).^2./(1+y(end,19*ncells+1:20*ncells).^2)))./0.001);
                all_tip2(k,EE)= sum(y(end,21*ncells+1:21*ncells+ncells)>Fmin_to_be_tip)/ncells;
                if eff_lfng==1
                    all_Lfng2(k,EE)=mean((-0.6121.*y(end,8*ncells+1:9*ncells) + 1.0578)*0.002);
                else
                    all_Lfng2(k,EE)=0.002;
                end
            
                %check pattern & define patterning time 
                tipnr =0; stalknr =0;
                define=length(t);
                time = 2*86400;
                tt= linspace(1,time,define); 
                tipt=zeros(1,ncells); stalkt = zeros(1,ncells);
                avg_time_to_pattern=0;
                tipsm=zeros(define,1); stalksm=zeros(define,1);
                check_pat =0;

                for q = 1:ncells
                    if y(end,21*ncells+q)>=Fmin_to_be_tip %Check if the cell is a tip cell at the end of the simulation
                        tipnr = tipnr+1; % Add +1 for count of tip cells
                        tip1 = fit(t,y(:,21*ncells+q),'smoothingspline'); %interpolate to allow for patterning times in between evaluations of ODE solver
                        tipsm= tipsm + tip1(tt); %Create interpolated vector for tip cells
                        check_pat=check_pat +1; %Check value to check if the pattern is established correctly (not two adjacent tip cells)
                        indxpat = find(tip1(tt)>=Fmin_to_be_tip); %Find the timepoints at which the nr of filopodia was above threshold for the cells (at what point it started to be a tip cell)
                        tipt(q)= tipt(q)+tt(indxpat(1)); %Add the first time point at which it was defined as a tip cell to the tip-patterning time vector
                    else
                        stalk1 = fit(t,y(:,21*ncells+q),'smoothingspline'); %Also create interpolated function for presumed stalk cells
                        stalknr = stalknr+1;  %Add +1 for count of stalk cells
                        stalksm = stalksm + stalk1(tt); %Create interpolated vector for stalk cells
                        if check_pat == 1 
                            check_pat = 0; %If patterning is going okay, this value should never get higher than 1 (that would indicate two adjacent tip cells)
                        end
                        indxpat = find(stalk1(tt)>Fmin_to_be_tip); %search for timepoints at which this cell had too many filopodia to be defined as a stalk cell
                        if ~isempty(indxpat) 
                            stalkt(q)=stalkt(q)+tt(indxpat(end)); %Add the last timepoint at which the cell had too many filopodia (from this moment onwards, this cell would become a stalk cell, as it had few enough filopodia)
                        else
                            stalkt(q)=0;
                        end
                    end
                end
                if (check_pat <= 1) && (tipnr >= 0.4*ncells)
                    if tipt(1)>0 && tipt(end)>0 
                        tiptime2(k,EE) = 86400;%Set patterning time to maximum simulated time (to indicate, no pattern);
                    else
                        tipttt = find(tipt>0);
                        stalkttt = find(stalkt>0);
                        tiptm = sum(tipt(tipttt))/length(tipttt);
                        stalktm = sum(stalkt(stalkttt))/length(stalkttt);
                        tiptime2(k,EE)= max([tiptm stalktm]);
                    end
                else
                    tiptime2(k,EE) = 86400;%Set patterning time to maximum simulated time (to indicate, no pattern);
                end  

            end

        end
        all_fak(i,:)=mean(all_fak2);
        all_RhoA(i,:)=mean(all_RhoA2);
        all_Rock(i,:)=mean(all_Rock2);
        all_mDia(i,:)=mean(all_mDia2);
        all_Myo(i,:)=mean(all_Myo2);
        all_Limk(i,:)=mean(all_Limk2);
        all_Cofilin(i,:)=mean(all_Cofilin2);
        all_Fcyto(i,:)=mean(all_Fcyto2);
        all_Yaptaz(i,:)=mean(all_Yaptaz2);
        all_mal(i,:)=mean(all_mal2);
        Fstress(i,:)=mean(Fstress2);
        all_VR(i,:)=mean(all_VR2);
        all_v_VR(i,:)=mean(all_v_VR2);
        all_DL(i,:)=mean(all_DL2);
        all_DR(i,:)=mean(all_DR2);
        all_NL(i,:)=mean(all_NL2);
        all_NR(i,:)=mean(all_NR2);
        all_D_NL(i,:)=mean(all_D_NL2);
        all_D_NR(i,:)=mean(all_D_NR2);
        all_I(i,:)=mean(all_I2);
        all_HE(i,:)=mean(all_HE2);
        all_F(i,:)=mean(all_F2);
        all_D_N_ext(i,:)=mean(all_D_N_ext2);
        V(i,:)=mean(V2); 
        DGG(i,:)= mean(DGG2);
        HH(i,:)=mean(HH2);
        all_tip(i,:)= mean(all_tip2);
        tiptime(i,:) = mean(tiptime2);
        all_Lfng(i,:) = mean(all_Lfng2);
        
        save("YAPTAZ_CF_DL_YP", 'all_Yaptaz2');
        save("NICD_CF_DL_YP", 'all_I2');
        save("Lfng_CF_DL_YP", 'all_Lfng2');
        save("DLL4_CF_DL_YP", 'DGG2');

end




