listnames =["SC.mat","SC_DL_YP.mat","SC_LF_YP.mat","SC_DL_LF_YP.mat","CF.mat","CF_DL_YP.mat","CF_LF_YP.mat","CF_LF_DL_YP.mat","ND_CF.mat","ND_CF_DL_YP.mat","ND_CF_LF_YP.mat","CF_ND_LF_DL_YP.mat"];
stiffnesrange= [0.5 1.5 2.5 3.7 4.7 5.6 6.6 7.6 8.7 9.8 11.2 12.7 14.6 17 20.1 24.2 30 38.5 52.6 70 79.5 143 380 400];
XX=categorical({'0.5','1.5','2.5','3.7','4.7','5.6','6.6','7.6','8.7','9.8','11.2','12.7','14.6','17','20.1','24.2','30','38.5','52.6','70','79.5','143','380','400'});
XX=reordercats(XX,{'0.5','1.5','2.5','3.7','4.7','5.6','6.6','7.6','8.7','9.8','11.2','12.7','14.6','17','20.1','24.2','30','38.5','52.6','70','79.5','143','380','400'});
markers=["--o","--square","--diamond","--^"];
colours=[[0.27 0.47 0.67],[0.8 0.4 0.47],[0.87 0.8 0.47],[0.07 0.47 0.2]];
sz=[9,6,7,4];

load("YAPTAZ_SC.mat");
YTt=median(all_Yaptaz2);
prctiles = prctile(all_Yaptaz2,[25 75]); %For each case, determining the IQR for the errorbars
dneg=YTt-prctiles(1,:); 
dpos=prctiles(2,:)-YTt;
figure(2),subplot(2,4,1),errorbar(stiffnesrange,YTt,dneg,dpos,'-x','MarkerSize',7,'Color','k','LineWidth',3) 
xlabel('Stiffness [kPa]'),ylabel('Fraction of nuclear YAP/TAZ'),title('General')

x=1;
for i=1:4
    clear all_Yaptaz2 all_I2 all_Lfng2 DGG2
    
    %NICD plots
    load(strcat("NICD_",listnames(i))); %Single cells with DLL4 coating
    I2t=median(all_I2);
    prctiles = prctile(all_I2,[25 75]);
    dneg=I2t-prctiles(1,:);
    dpos=prctiles(2,:)-I2t;
    figure(2),subplot(2,4,8),errorbar(stiffnesrange,(I2t./mean(all_I2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on
    xlabel('Stiffness [kPa]'),ylabel('Normalized NICD')
    clear all_I2 
    
    load(strcat("NICD_",listnames(i+4)));    %Confluent and DLL4 coating
    I2t=median(all_I2);
    prctiles = prctile(all_I2,[25 75]);
    dneg=I2t-prctiles(1,:);
    dpos=prctiles(2,:)-I2t;
    figure(2),subplot(2,4,7),errorbar(stiffnesrange,(I2t./mean(all_I2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on    
    clear all_I2
    xlabel('Stiffness [kPa]'),ylabel('Normalized NICD')
    
    load(strcat("NICD_",listnames(i+8)));   %Confluent without DLL4 coating
    I2t=median(all_I2);
    prctiles = prctile(all_I2,[25 75]);
    dneg=I2t-prctiles(1,:); 
    dpos=prctiles(2,:)-I2t;
    figure(2),subplot(2,4,6),errorbar(stiffnesrange,(I2t./mean(all_I2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on    
    xlabel('Stiffness [kPa]'),ylabel('Normalized NICD')
    
    %DLL4 plots
    load(strcat("DLL4_",listnames(i))); %Single cells with DLL4 coating
    DGt=median(DGG2);
    prctiles = prctile(DGG2,[25 75]);
    dneg=DGt-prctiles(1,:); 
    dpos=prctiles(2,:)-DGt;
    figure(2),subplot(2,4,4),errorbar(stiffnesrange,(DGt./mean(DGG2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on    
    clear DGG2 
    xlabel('Stiffness [kPa]'),ylabel('Normalized Dll4 expression'),title('Single cells with DLL4_e_x_t')
    
    load(strcat("DLL4_",listnames(i+4)));    %Confluent and DLL4 coating
    DGt=median(DGG2);
    prctiles = prctile(DGG2,[25 75]);
    dneg=DGt-prctiles(1,:);
    dpos=prctiles(2,:)-DGt;
    figure(2),subplot(2,4,3),errorbar(stiffnesrange,(DGt./mean(DGG2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on  
    clear DGG2
    xlabel('Stiffness [kPa]'),ylabel('Normalized Dll4 expression'),title('Confluent cells with DLL4_e_x_t')
    
    load(strcat("DLL4_",listnames(i+8)));   %Confluent without DLL4 coating
    DGt=median(DGG2);
    prctiles = prctile(DGG2,[25 75]);
    dneg=DGt-prctiles(1,:);
    dpos=prctiles(2,:)-DGt;
    figure(2),subplot(2,4,2),errorbar(stiffnesrange,(DGt./mean(DGG2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on  
    xlabel('Stiffness [kPa]'),ylabel('Normalized Dll4 expression'),title('Confluent cells without DLL4_e_x_t')
    
    %Lfng plot
    load(strcat("Lfng_",listnames(i)));    %I now took the SC case
    LFt=median(all_Lfng2);
    prctiles = prctile(all_Lfng2,[25 75]);
    dneg=LFt-prctiles(1,:); 
    dpos=prctiles(2,:)-LFt;
    figure(2),subplot(2,4,5),errorbar(stiffnesrange,(LFt./mean(all_Lfng2(:,2))),dneg,dpos,markers(i),'MarkerSize',sz(i),'Color',colours(x:x+2),'LineWidth',3), hold on  
    xlabel('Stiffness [kPa]'),ylabel('Normalized Lfng expression')
    legend('No interactions','YAP/TAZ-DLL4','YAP/TAZ-Lfng','YAP/TAZ-DLL4 & YAP/TAZ-Lfng')
    x=x+3;
    
    
end