close all
clearvars
listnames=["No_int.mat","F-No_int.mat","YT-DL.mat","F-YT-DL.mat","YT-LF.mat","F-YT-LF.mat","YT-DL-LF.mat","F-YT-DL-LF.mat"];
titlelist=["No interactions","YAP/TAZ-DLL4","YAP/TAZ-Lfng","YAP/TAZ-DLL4 & YAP/TAZ-Lfng"];
X = categorical({'0.5','1.5','7.6','9.8','12.7','14.6','17','38.5','400'});
X=reordercats(X,{'0.5','1.5','7.6','9.8','12.7','14.6','17','38.5','400'});
xx=[1 2 8 10 12 13 14 18 24];
clrs =[[68 119 170],[204 102 119],[221 204 119],[17 119 51]];
ordr1=[1 4 7 10];
ordr2=[3 6 9 12];
lindP=[1 3 5 7]; lindF=[2 4 6 8];
dP=[1 3 1 3]; dF=[2 4 2 4];


for i = 1:4
    
    indP = lindP(i);
    indF = lindF(i);
    
    load(listnames(indP));
    tiptimee=24./((tiptime2(:,xx)./3600)-24); %calculate patterning time in hours
    tiptimee(tiptimee==1)=0;

    figure(3),subplot(4,2,lindP(i)),boxplot(tiptimee,X)
    xlabel('Stiffness [kPa]')
    ylabel('Patterning rate [24h/h]')
    ylim([-0.5 8])
    box on
    set(gca, 'Fontsize', 12, 'linewidth', 1)
    set(findobj(gca,'type','line'),'linew',1)
    set(gca, 'Fontsize', 12, 'linewidth', 1)
    colors = rand(4, 3);
    h = findobj(gca,'Tag','Box');
    for ii = 1:9 
        patch(get(h(ii),'XData'),get(h(ii),'YData'),clrs(ordr1(i):ordr2(i))./255,'FaceAlpha',.7,'LineWidth',.5);
    end
    title(titlelist(i))

    percentile = 90;
    
    load(listnames(indF));
    Filoo=filoav_all(:,xx);

    figure(3),subplot(4,2,lindF(i)),boxplot(Filoo,X)
    xlabel('Stiffness [kPa]')
    ylabel('Nr of filopodia before patterning')
    ylim([0 90])
    box on
    set(gca, 'Fontsize', 12, 'linewidth', 1)
    set(findobj(gca,'type','line'),'linew',1)
    set(gca, 'Fontsize', 12, 'linewidth', 1)
    colors = rand(4, 3);
    h = findobj(gca,'Tag','Box');
    for ii = 1:9 
        patch(get(h(ii),'XData'),get(h(ii),'YData'),clrs(ordr1(i):ordr2(i))./255,'FaceAlpha',.7,'LineWidth',.5);
    end
    title(titlelist(i))

    percentile = 90;
    
    clear filoav_all
end