clearvars
%close all

stiff = 1.5; %Determine the stiffness for which you are plotting
eff_lfng = 1; %Effect of YAP/TAZ on Lfng, 0 = no effect, 1 = YAP/TAZ inhibits Lfng
ncells = 10;
lambda = 0.1;%0.1; %Effect of YAP/TAZ on Dll4, set lambda to 1 for no effect
nn = 6.5; Yap0 = 0.47; 

[t1, y, tip, stalk, ttt, avgtime_to_pattern, time_to_pattern1,ntip] = RowCells(stiff,eff_lfng,ncells,lambda,nn,Yap0);

plotnumber = 21;
tini = 1; start = find(t1>tini);

Filopodia = zeros(ncells, length(ttt));


for cellnum = 1:ncells
      cell1 = fit(t1(start(1):end),y(start(1):end,plotnumber*ncells+cellnum),'smoothingspline');
      Filopodia(cellnum,:) = cell1(ttt);
end

[grad,im]=colorGradient([100,100,180]/255,[80,180,80]/255,128);


figure(1),subplot(1,4,1),prova = colormap(grad);
%Change the last number of the subplot number (1,4,X) to a value between
%1-4 to change the panel that you are plotting
Filopodia = Filopodia';

loca=find(ttt>=86000);
loca2=find(ttt>=115200);
tt=ttt(loca(1):loca2);
Filopodiaa=Filopodia(loca(1):loca2,:);

h = heatmap(Filopodiaa);
h.GridVisible = 'off';
h.NodeChildren(3).YDir='normal';    

% Replace all but the fifth elements by spaces
tt = tt-tini;
i = 1;
while i <= length(tt)
    if mod(i,length(tt)/2) ~= 0
        CustomYLabels(i) = " ";
    else
        CustomYLabels(i) = string(round(tt(i)/3600)-24);
    end
    i=i+1;
end

% Set the 'XDisplayLabels' property of the heatmap 
% object 'h' to the custom x-axis tick labels
h.YDisplayLabels = CustomYLabels;
h.Colormap = prova;
ylabel('Patterning time [h]')
xlabel('Cell index')
annotation('textarrow',[1,1],[0.5,0.5],'string','Filopodia', ...
      'FontSize', 12,...
      'HeadStyle','none','LineStyle','none',...
      'HorizontalAlignment','center','TextRotation',90);
title('1.5 kPa') %Make sure the title corresponds with what you are plotting
set(h, 'Fontsize',12)

Patterningtimeh=24/((avgtime_to_pattern/(60*60))-24);
