listnames =["Myo_KD.mat","Myo_OE.mat","ROCK_KD.mat","ROCK_OE.mat","Fcyto_KD.mat","Fcyto_OE.mat","Rho_KD.mat","Rho_OE.mat","Cofilin_KD.mat","Cofilin_OE.mat","Control"];
stiffnesrange= [1.5 9.8 10 70];
XX=categorical({'0.5','1.5','2.5','3.7','4.7','5.6','6.6','7.6','8.7','9.8','11.2','12.7','14.6','17','20.1','24.2','30','38.5','52.6','70','79.5','143','380','400'});
XX=reordercats(XX,{'0.5','1.5','2.5','3.7','4.7','5.6','6.6','7.6','8.7','9.8','11.2','12.7','14.6','17','20.1','24.2','30','38.5','52.6','70','79.5','143','380','400'});
markers=[":o",":square",":diamond",":^",":*"];
colours=[[0.98 0.74 0.49],[0.82 0.30 0.24],[0.93 0.53 0.37],[0.68 0.11 0.24],[1 0.89 0.67],[0.71 0.87 0.97],[0.23 0.54 0.79],[0.47 0.72 0.90],[0.24 0.32 0.63],[0.5 0.5 0.5]];
sz=[9,8,7,4,6,6];

load("YAPTAZ_Control.mat"); 
YT=median(all_Yaptaz2(:,[1 2 4]));
prctiles=prctile(all_Yaptaz2(:,[1 2 4]),[25 75]);
dneg=YT-prctiles(1,:);
dpos=prctiles(2,:)-YT;
figure(1),subplot(2,4,1),errorbar(stiffnesrange([1 2 4]),YT,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Fraction of nuclear YAP/TAZ'),title('Down-regulated cytoskeletal elements')
figure(1),subplot(2,4,2),errorbar(stiffnesrange([1 2 4]),YT,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Fraction of nuclear YAP/TAZ'),title('Upregulated cytoskeletal elements')

load("tiptime_Control.mat");
xxxx=find(tiptime2==172800);
tiptime2(xxxx)=tiptime2(xxxx)/2;
ctTime=24./((median(tiptime2(:,1)./(60*60)))-24);
Time=24./((median(tiptime2(:,[1 2 4])./(60*60)))-24);
prctiles=prctile(24./(((tiptime2(:,[1 2 4])./(60*60)))-24),[25 75]);
dneg=Time-prctiles(1,:); dneg(isnan(dneg))=0;
dpos=prctiles(2,:)-Time; dpos(isnan(dpos))=0; Time(Time==Inf)=1;
figure(1),subplot(2,4,3),errorbar(stiffnesrange([1 2 4]),Time,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Patterning rate [24h/h]'),title('Down-regulated cytoskeletal elements')
figure(1),subplot(2,4,4),errorbar(stiffnesrange([1 2 4]),Time,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Patterning rate [24h/h]'),title('Upregulated cytoskeletal elements')

load("Lfng_Control.mat");
LF=median(all_Lfng2(:,[1 2 4]));
ctLF=median(all_Lfng2(:,1));
LF=LF./ctLF;
prctiles=prctile(all_Lfng2(:,[1 2 4])./ctLF,[25 75]);
dneg=LF-prctiles(1,:);
dpos=prctiles(2,:)-LF;
figure(1),subplot(2,4,5),errorbar(stiffnesrange([1 2 4]),LF,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Normalized Lfng'),title('Down-regulated cytoskeletal elements')
figure(1),subplot(2,4,6),errorbar(stiffnesrange([1 2 4]),LF,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Normalized Lfng'),title('Upregulated cytoskeletal elements')

load("DLL4_Control.mat");
DL=median(DGG2(:,[1 2 4]));
ctDL=median(DGG2(:,1));
DL=DL./ctDL;
prctiles=prctile(DGG2(:,[1 2 4])./ctDL,[25 75]);
dneg=DL-prctiles(1,:);
dpos=prctiles(2,:)-DL;
figure(1),subplot(2,4,7),errorbar(stiffnesrange([1 2 4]),DL,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Normalized DLL4 gene expression'),title('Down-regulated cytoskeletal elements')
figure(1),subplot(2,4,8),errorbar(stiffnesrange([1 2 4]),DL,dneg,dpos,'-x','MarkerSize',7','Color','k','LineWidth',3), hold on
xlabel('Stiffness [kPa]'),ylabel('Normalized DLL4 gene expression'),title('Upregulated cytoskeletal elements')

x=1;
xx=1;
for i=1:2:10
    clear all_Yaptaz2 tiptime2 all_Lfng2 DGG2
    
    load(strcat("YAPTAZ_",listnames(i)));
    YT=median(all_Yaptaz2(:,[1 2 4]));
    prctiles=prctile(all_Yaptaz2(:,[1 2 4]),[25 75]);
    dneg=YT-prctiles(1,:);
    dpos=prctiles(2,:)-YT;
    figure(1),subplot(2,4,1),errorbar(stiffnesrange([1 2 4]),YT,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x:x+2),'LineWidth',2),hold on
    clear all_Yaptaz2 
    load(strcat("YAPTAZ_",listnames(i+1)));
    YT=median(all_Yaptaz2(:,[1 2 4]));
    prctiles=prctile(all_Yaptaz2(:,[1 2 4]),[25 75]);
    dneg=YT-prctiles(1,:);
    dpos=prctiles(2,:)-YT;
    figure(1),subplot(2,4,2),errorbar(stiffnesrange([1 2 4]),YT,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x+15:x+17),'LineWidth',2),hold on    
    
    load(strcat("tiptime_",listnames(i)));
    xxxx=find(tiptime2==172800);
    tiptime2(xxxx)=tiptime2(xxxx)/2;
    Time=24./((median(tiptime2(:,[1 2 4])./(60*60)))-24);
    prctiles=prctile(24./(((tiptime2(:,[1 2 4])./(60*60)))-24),[25 75]);
    dneg=Time-prctiles(1,:); dneg(isnan(dneg))=0;
    dpos=prctiles(2,:)-Time; dpos(isnan(dpos))=0; Time(Time==Inf)=1;
    figure(1),subplot(2,4,3),errorbar(stiffnesrange([1 2 4]),Time,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x:x+2),'LineWidth',2),hold on
    clear tiptime2 
    load(strcat("tiptime_",listnames(i+1)));
    Time=24./((median(tiptime2(:,[1 2 4])./(60*60)))-24);
    prctiles=prctile(24./(((tiptime2(:,[1 2 4])./(60*60)))-24),[25 75]);
    dneg=Time-prctiles(1,:);
    dpos=prctiles(2,:)-Time;
    figure(1),subplot(2,4,4),errorbar(stiffnesrange([1 2 4]),Time,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x+15:x+17),'LineWidth',2),hold on    
    
    load(strcat("DLL4_",listnames(i)));
    DL=(median(DGG2(:,[1 2 4])))./ctDL;
    prctiles=prctile(DGG2(:,[1 2 4])./ctDL,[25 75]);
    dneg=DL-prctiles(1,:);
    dpos=prctiles(2,:)-DL;
    figure(1),subplot(2,4,7),errorbar(stiffnesrange([1 2 4]),DL,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x:x+2),'LineWidth',2),hold on
    clear DGG2 
    load(strcat("DLL4_",listnames(i+1)));
    DL=median(DGG2(:,[1 2 4]))./ctDL;
    prctiles=prctile(DGG2(:,[1 2 4])./ctDL,[25 75]);
    dneg=DL-prctiles(1,:);
    dpos=prctiles(2,:)-DL;
    figure(1),subplot(2,4,8),errorbar(stiffnesrange([1 2 4]),DL,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x+15:x+17),'LineWidth',2),hold on    
    
    load(strcat("Lfng_",listnames(i)));
    LF=median(all_Lfng2(:,[1 2 4]))./ctLF;
    prctiles=prctile(all_Lfng2(:,[1 2 4])./ctLF,[25 75]);
    dneg=LF-prctiles(1,:);
    dpos=prctiles(2,:)-LF;
    figure(1),subplot(2,4,5),errorbar(stiffnesrange([1 2 4]),LF,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x:x+2),'LineWidth',2),hold on
    clear all_Lfng2 
    load(strcat("Lfng_",listnames(i+1)));
    LF=median(all_Lfng2(:,[1 2 4]))./ctLF;
    prctiles=prctile(all_Lfng2(:,[1 2 4])./ctLF,[25 75]);
    dneg=LF-prctiles(1,:);
    dpos=prctiles(2,:)-LF;
    figure(1),subplot(2,4,6),errorbar(stiffnesrange([1 2 4]),LF,dneg,dpos,markers(xx),'MarkerSize',sz(xx),'Color',colours(x+15:x+17),'LineWidth',2),hold on    
    
    x=x+3; 
    xx=xx+1;
end
figure(1),subplot(2,4,1),legend('Control','Myo','ROCK','Fcyto','Rho','Cofilin')
figure(1),subplot(2,4,2),legend('Control','Myo','ROCK','Fcyto','Rho','Cofilin')