clear all

Dll4_ext = 0;%No exposure to external DLL4 for these simulations
Fmin_to_be_tip = 20; %Threshold for the amount of filopodia (tip/stalk)
ncells=18; %adjusted so that we can simulat two patches of 200 um

lambda = 0.1; Yap0 = 0.47; nn = 6.5;
%If you want to 'stop' the inhibitory relation between YAP/TAZ and DLL4,
%set lambda = 1

nrrpts = 25;%Amount of repeats
mdnvalues=zeros(24,24);
mdnvaluest=zeros(24,24);
tipvalues=zeros(24,24); 
filovalues=zeros(24,24);

nms = ["0,5", "1,5", "2,5", "3,7", "4,7", "5,6", "6,6", "7,6", "8,7", "9,8", "11,2", "12,7", "14,6", "17", "20,1", "24,2", "30", "38,5", "52,6", "70", "79,5", "143", "380", "400"];
stiffnesrange= [0.5 1.5 2.5 3.7 4.7 5.6 6.6 7.6 8.7 9.8 11.2 12.7 14.6 17 20.1 24.2 30 38.5 52.6 70 79.5 143 380 400];
loopvar = stiffnesrange;%Loop through both stiffness ranges
loopvar2 = stiffnesrange;

%pre-allocation of vectors
all_fak = zeros(length(loopvar),ncells);
all_RhoA = zeros(length(loopvar),ncells);
all_Rock = zeros(length(loopvar),ncells);
all_mDia = zeros(length(loopvar),ncells);
all_Myo = zeros(length(loopvar),ncells);
all_Limk = zeros(length(loopvar),ncells);
all_Cofilin = zeros(length(loopvar),ncells);
all_Fcyto = zeros(length(loopvar),ncells);
all_Yaptaz = zeros(length(loopvar),ncells);
all_mal = zeros(length(loopvar),ncells);
Fstress = zeros(length(loopvar),ncells);
all_VR = zeros(length(loopvar),ncells);
all_v_VR = zeros(length(loopvar),ncells);
all_DL = zeros(length(loopvar),ncells);
all_DR = zeros(length(loopvar),ncells);
all_NL = zeros(length(loopvar),ncells);
all_NR = zeros(length(loopvar),ncells);
all_D_NL = zeros(length(loopvar),ncells);
all_D_NR = zeros(length(loopvar),ncells);
all_I = zeros(length(loopvar),ncells);
all_HE = zeros(length(loopvar),ncells);
all_F = zeros(length(loopvar),ncells);
V = zeros(length(loopvar),ncells);
DGG = zeros(length(loopvar),ncells);
HH = zeros(length(loopvar),ncells);
all_D_N_ext = zeros(length(loopvar),ncells);
all_tip = zeros(length(loopvar),ncells);
tiptime=zeros(length(loopvar),ncells);
tiptime3=zeros(1,nrrpts);
tippnr=zeros(1,nrrpts);

for ii = 1:length(loopvar)
    stifn1=loopvar(ii);
    for i=1:length(loopvar2)
        stifn2=loopvar2(i);
        %size of the stiffness patch is 200 um, or 9 cells approximately
        stiffnessvector=[stifn1 stifn1 stifn1 stifn1 stifn1 stifn1 stifn1 stifn1 stifn1 stifn2 stifn2 stifn2 stifn2 stifn2 stifn2 stifn2 stifn2 stifn2];
        LD=1;
        E=1;
        c=7.5;
        lambda = 0.1;
        time=20000;
        ncombs=10;
        threshold_rock_s=0.1;
        smoothing_range_s=0.2;
        Fak_total_s= 1;
        RhoA_total_s=1;
        Rock_total_s=1;
        mDia_total_s= 1;
        Myo_total_s= 1;
        Limk_total_s=1;
        Cofilin_total_s=1;
        Fcyto_total_s=1;
        Yaptaz_total_s=1;
        mal_total_s=1;
        Fstrtot=1;
        y_parameter_s=500;
        Fak0=rand(1,ncells)*0;
        RhoA0=rand(1,ncells)*0;
        Rock0=rand(1,ncells)*0;
        mDia0=rand(1,ncells)*0;
        Myo0=rand(1,ncells)*0;
        Limk0=rand(1,ncells)*0;
        Cofilin0=rand(1,ncells)*0;
        Fcyto0=rand(1,ncells)*0;
        Yaptaz0=rand(1,ncells)*0;
        mal0=rand(1,ncells)*0;
        Fstr0=rand(1,ncells)*0;

        %Starting values for VEGF model
        VR0(1,1:ncells)= ones(1,ncells)*0.000000;%random value of VR initially expressed by cells
        v_VR0(1,1:ncells)= rand(1,ncells)*0.000000; %random value of VEGF-VEGFR initially expressed by cells
        DL0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of Delta initially expressed by cells
        DR0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of Delta initially expressed by cells
        NL0(1,1:ncells)= ones(1,ncells)*0.0000000; %value of Notch initially expressed by cells
        NR0(1,1:ncells)= ones(1,ncells)*0.0000000; %value of Notch initially expressed by cells
        D_NL0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of bound Delta_Notch initially present in cells
        D_NR0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of bound Delta_Notch initially present in cells
        I0(1,1:ncells)= rand(1,ncells)*0.00000000; %random value of NICD initially present in cells;
        HE0(1,1:ncells)= rand(1,ncells)*0.0000000; %random value of HES+HEY+HER initially expressed by cells;
        F0(1,1:ncells)= rand(1,ncells)*0.0000000; %value of filopodia initially present in cells;
        Dext_NL0 = rand(1,ncells)*0.000000; %value of bound Delta(ext)_Notch initially present in cells
        Dext_NR0 = rand(1,ncells)*0.000000; %value of bound Delta(ext)_Notch initially present in cells

        prods = Dll4_ext;

        x=1;
        j=0;

        all_fak2 = zeros(nrrpts,ncells);
        all_RhoA2 = zeros(nrrpts,ncells);
        all_Rock2 = zeros(nrrpts,ncells);
        all_mDia2 = zeros(nrrpts,ncells);
        all_Myo2 = zeros(nrrpts,ncells);
        all_Limk2 = zeros(nrrpts,ncells);
        all_Cofilin2 = zeros(nrrpts,ncells);
        all_Fcyto2 = zeros(nrrpts,ncells);
        all_Yaptaz2 = zeros(nrrpts,ncells);
        all_mal2 = zeros(nrrpts,ncells);
        Fstress2 = zeros(nrrpts,ncells);
        all_VR2 = zeros(nrrpts,ncells);
        all_v_VR2 = zeros(nrrpts,ncells);
        all_DL2 = zeros(nrrpts,ncells);
        all_DR2 = zeros(nrrpts,ncells);
        all_NL2 = zeros(nrrpts,ncells);
        all_NR2 = zeros(nrrpts,ncells);
        all_D_NL2 = zeros(nrrpts,ncells);
        all_D_NR2 = zeros(nrrpts,ncells);
        all_I2 = zeros(nrrpts,ncells);
        all_HE2 = zeros(nrrpts,ncells);
        all_F2 = zeros(nrrpts,ncells);
        V2 = zeros(nrrpts,ncells);
        DGG2 = zeros(nrrpts,ncells);
        HH2 = zeros(nrrpts,ncells);
        all_D_N_ext2 = zeros(nrrpts,ncells);
        all_tip2 = zeros(nrrpts,ncells);
        tiptime2=zeros(nrrpts,ncells);

            for k =1:nrrpts
                k
                rng('shuffle')

                options=odeset('Reltol',1e-12,'AbsTol',1e-6, 'MaxStep', 100);
                VEGF_ext = 0.0300000;%high enough VEGF to instigate patterning

                 %Define the input here, to take the variability of it into
                %account and average over it by the repeats
                 input=[threshold_rock_s;smoothing_range_s;Fak_total_s;RhoA_total_s;Rock_total_s;mDia_total_s;Myo_total_s;Limk_total_s;Cofilin_total_s;Fcyto_total_s;LD;0;y_parameter_s;c;Yaptaz_total_s;mal_total_s];
                 V0(1,1:ncells) = ones(1,ncells)*0.0000000 +rand(1,ncells)*10^(-8); % value of V initially seen by cells
                 y0=[Fak0,RhoA0,Rock0,mDia0,Myo0,Limk0,Cofilin0,Fcyto0,Yaptaz0,mal0,Fstr0, VR0,v_VR0,DL0,DR0,NL0,NR0,D_NL0,D_NR0,I0,HE0,F0,Dext_NL0,Dext_NR0];

                EE = stiffnessvector;
                j=j+1;
                input(12)=0;
                [t,y]=ode15s(@differentationequations_LF,[0 2*86400],y0,options,input,ncells,VEGF_ext,V0',lambda,nn,Yap0,prods,EE);
                all_fak2(k,1:ncells)=(y(end,1:ncells));
                all_RhoA2(k,1:ncells)=(y(end,ncells+1:2*ncells));
                all_Rock2(k,1:ncells)=(y(end,2*ncells+1:3*ncells));
                all_mDia2(k,1:ncells)=(y(end,3*ncells+1:4*ncells));
                all_Myo2(k,1:ncells)=(y(end,4*ncells+1:5*ncells));
                all_Limk2(k,1:ncells)=(y(end,5*ncells+1:6*ncells));
                all_Cofilin2(k,1:ncells)=(y(end,6*ncells+1:7*ncells));
                all_Fcyto2(k,1:ncells)=(y(end,7*ncells+1:8*ncells));
                all_Yaptaz2(k,1:ncells)=(y(end,8*ncells+1:9*ncells));
                all_mal2(k,1:ncells)=(y(end,9*ncells+1:10*ncells));
                Fstress2(k,1:ncells)=(y(end,7*ncells+1:8*ncells).*y(end,4*ncells+1:5*ncells));
                all_VR2(k,1:ncells)=(y(end,11*ncells+1:12*ncells));
                all_v_VR2(k,1:ncells)=(y(end,12*ncells+1:13*ncells));
                all_DL2(k,1:ncells)=(y(end,13*ncells+1:14*ncells));
                all_DR2(k,1:ncells)=(y(end,14*ncells+1:15*ncells));
                all_NL2(k,1:ncells)=(y(end,15*ncells+1:16*ncells));
                all_NR2(k,1:ncells)=(y(end,16*ncells+1:17*ncells));
                all_D_NL2(k,1:ncells)=(y(end,17*ncells+1:18*ncells));
                all_D_NR2(k,1:ncells)=(y(end,18*ncells+1:19*ncells));
                all_I2(k,1:ncells)=(y(end,19*ncells+1:20*ncells));
                all_HE2(k,1:ncells)=(y(end,20*ncells+1:21*ncells));
                all_F2(k,1:ncells)=(y(end,21*ncells+1:22*ncells));
                all_D_N_ext2(k,1:ncells)= (y(end,22*ncells+1:23*ncells)+y(end,23*ncells+1:24*ncells));
                V2(k,1:ncells)=(V0+0.001.*V0.*y(end,21*ncells+1:22*ncells).^2); 
                DGG2(k,1:ncells)=(((0.001 + 0.1*y(end,12*ncells+1:13*ncells).^2./(1+y(end,12*ncells+1:13*ncells).^2))/2).*(lambda+((1-lambda)./((1+(y(end,8*ncells+1:9*ncells))./Yap0).^nn))));
                HH2(k,1:ncells)=(((0.001 + 0.1*y(end,19*ncells+1:20*ncells).^2./(1+y(end,19*ncells+1:20*ncells).^2)))./0.001);
                all_tip2(k,1:ncells)= y(end,21*ncells+1:21*ncells+ncells)>Fmin_to_be_tip;

                %check pattern & define patterning time 
                tipnr =0; stalknr =0;
                define=length(t);
                time = 2*86400;
                tt= linspace(1,time,define); 
                tipt=zeros(1,ncells); stalkt = zeros(1,ncells);
                avg_time_to_pattern=0;
                tipsm=zeros(define,1); stalksm=zeros(define,1);
                check_pat =0;

                for q = 1:ncells
                    if y(end,21*ncells+q)>=Fmin_to_be_tip %Check if the cell is a tip cell at the end of the simulation
                        tipnr = tipnr+1; % Add +1 for count of tip cells
                        tip1 = fit(t,y(:,21*ncells+q),'smoothingspline'); %interpolate to allow for patterning times in between evaluations of ODE solver
                        tipsm= tipsm + tip1(tt); %Create interpolated vector for tip cells
                        check_pat=check_pat +1; %Check value to check if the pattern is established correctly (not two adjacent tip cells)
                        indxpat = find(tip1(tt)>=Fmin_to_be_tip); %Find the timepoints at which the nr of filopodia was above threshold for the cells (at what point it started to be a tip cell)
                        tipt(q)= tipt(q)+tt(indxpat(1)); %Add the first time point at which it was defined as a tip cell to the tip-patterning time vector
                        tiptime2(k,q)=tipt(q);
                    else
                        stalk1 = fit(t,y(:,21*ncells+q),'smoothingspline'); %Also create interpolated function for presumed stalk cells
                        stalknr = stalknr+1;  %Add +1 for count of stalk cells
                        stalksm = stalksm + stalk1(tt); %Create interpolated vector for stalk cells
                        if check_pat == 1 
                            check_pat = 0; %If patterning is going okay, this value should never get higher than 1 (that would indicate two adjacent tip cells)
                        end
                        indxpat = find(stalk1(tt)>Fmin_to_be_tip); %search for timepoints at which this cell had too many filopodia to be defined as a stalk cell
                        if ~isempty(indxpat) 
                            stalkt(q)=stalkt(q)+tt(indxpat(end)); %Add the last timepoint at which the cell had too many filopodia (from this moment onwards, this cell would become a stalk cell, as it had few enough filopodia)
                            tiptime2(k,q)=stalkt(q);
                        else
                            stalkt(q)=0;
                            tiptime2(k,q)=0;
                        end
                    end
                end
                tippnr(1,k)=tipnr/ncells;
                if (check_pat <= 1) && (tipnr >= 0.4*ncells)
                    if tipt(1)>0 && tipt(end)>0 
                        tiptime3(1,k)=2*86400;
                    else
                        tipttt = find(tipt>0);
                        stalkttt = find(stalkt>0);
                        tiptm = sum(tipt(tipttt))/length(tipttt);
                        stalktm = sum(stalkt(stalkttt))/length(stalkttt);
                        tiptime3(1,k)= max([tiptm stalktm]);
                    end
                else
                    tiptime3(1,k) = 2*86400;
                end  

            end
            all_fak(i,:)=mean(all_fak2);
            all_RhoA(i,:)=mean(all_RhoA2);
            all_Rock(i,:)=mean(all_Rock2);
            all_mDia(i,:)=mean(all_mDia2);
            all_Myo(i,:)=mean(all_Myo2);
            all_Limk(i,:)=mean(all_Limk2);
            all_Cofilin(i,:)=mean(all_Cofilin2);
            all_Fcyto(i,:)=mean(all_Fcyto2);
            all_Yaptaz(i,:)=mean(all_Yaptaz2);
            all_mal(i,:)=mean(all_mal2);
            Fstress(i,:)=mean(Fstress2);
            all_VR(i,:)=mean(all_VR2);
            all_v_VR(i,:)=mean(all_v_VR2);
            all_DL(i,:)=mean(all_DL2);
            all_DR(i,:)=mean(all_DR2);
            all_NL(i,:)=mean(all_NL2);
            all_NR(i,:)=mean(all_NR2);
            all_D_NL(i,:)=mean(all_D_NL2);
            all_D_NR(i,:)=mean(all_D_NR2);
            all_I(i,:)=mean(all_I2);
            all_HE(i,:)=mean(all_HE2);
            all_F(i,:)=mean(all_F2);
            all_D_N_ext(i,:)=mean(all_D_N_ext2);
            V(i,:)=mean(V2); 
            DGG(i,:)= mean(DGG2);
            HH(i,:)=mean(HH2);
            all_tip(i,:)= mean(all_tip2);
            tiptime(i,:) = mean(tiptime2);

            mdnvaluest(ii,i)=24./((median(tiptime3)./3600)-24);
            mdnvalues(ii,i)=median(tiptime3);
            tipvalues(ii,i)=mean(tippnr);
            filovalues(ii,i)=mean(all_F(i,:));
    end
end
save("Time_all", 'mdnvaluest');
save("Time_all_sec", 'mdnvalues');
save("Tip_all", 'tipvalues');
save("Filo_all", 'filovalues');



