function dy= differentationequations_LF(t,y0,input,ncells,VEGF_ext,V0,lambda,nn,Yap0,prods,E)

% %initial conditions
%YAP/TAZ model
Fak   = y0(1:ncells);
RhoA = y0(ncells+1:2*ncells);
Rock    = y0(2*ncells+1:3*ncells);
mDia    = y0(3*ncells+1:4*ncells);
Myo    = y0(4*ncells+1:5*ncells);
Limk    = y0(5*ncells+1:6*ncells);
Cofilin  = y0(6*ncells+1:7*ncells);
Fcyto  = y0(7*ncells+1:8*ncells);
Yaptaz     = y0(8*ncells+1:9*ncells);
mal = y0(9*ncells+1:10*ncells);
Fstr = y0(10*ncells+1:11*ncells);

%Venkatraman model 
VR = y0(11*ncells+1:12*ncells);
v_VR = y0(12*ncells+1:13*ncells);
DL = y0(13*ncells+1:14*ncells);
DR = y0(14*ncells+1:15*ncells);
NL = y0(15*ncells+1:16*ncells); 
NR = y0(16*ncells+1:17*ncells); 
D_NL = y0(17*ncells+1:18*ncells);
D_NR = y0(18*ncells+1:19*ncells);
I = y0(19*ncells+1:20*ncells);
HE = y0(20*ncells+1:21*ncells);
F = y0(21*ncells+1:22*ncells);
Dext_NL = y0(22*ncells+1:23*ncells); 
Dext_NR = y0(23*ncells+1:24*ncells); 
if t>86400 %First 24h of acclimatization, then 24h exposure to VEGF
    V0=V0+VEGF_ext;
end

%total amount of signals and other input
threshold_rock=input(1);
smoothing_range=input(2);
Fak_total=input(3);
RhoA_total=input(4);
Rock_total=input(5);
mDia_total=input(6);
Myo_total=input(7);
Limk_total=input(8);
Cofilin_total=input(9);
Fcyto_total=input(10);

LD=input(11);
stiff=input(12);
y=input(13);
C=input(14);
Yaptaz_total=input(15);
mal_total=input(16);

k_sf=0.014;%0.0175; %1/s Sun
k_df=0.035; %1/s Sun
ksfkdf=0.225;%0.4;
k_fkp= 0.018; %1/s Sun
k_dp=0.625; %1/s Sun 
k_rp=2.2; %1/s Sun 
k_drock=0.8; %1/s Sun
k_mp=1; %1/s Sun
k_dmDia= 1; %1/s Sun

k_mr= 0.015; %1/s Sun
e=40; %Sun
k_dmy=0.067; %1/s Sun
k_lr=0.07; %1/s Sun
tau=200; %Sun
k_dl=2; %1/s Sun
k_turnover=0.04; %1/s Sun
k_cr=0.7; %1/s Sun
k_ll=0.8; %1/s Sun
k_ra=0.4; %1/s Sun
alfa=40; %Sun
k_dep=0.35; %1/s Sun
k_fc1=8 ; %Sun
k_CN=0.1; %1/s Sun
k_cy=20; %1/s Sun
k_NC=3; %1/s Sun
k_ly=6; %1/s Sun
k_cnm=0.2; %1/s Sun
k_ncm=1.2;
kmf=2;
LATS0 = 0.5;%1;
LATSP = 0.05;
RockB1=0.26;
RockB2=0.26;   
mdiaB=0.13;   
smoothingparameter1 = 10;
smoothingparameter2 = 13;

%parameters Venkatraman model 

k1=0.1;
k_1=0.001;
kcat1=0.1; %k4
k2=0.001*2;
k_2=0.1;
theta=0.1;
deg=0.005;
degD = 0.005;
degN = 0.005;
degDN = 0.005;
degI = 0.005;
degHE = 0.005;
kpf=0.005;
kprod1VR=0.005;
kprodN = 0.005;
kinh=0.005; %k3
konfa=1*0.1; %k5
kturnFA=0.001;
Diff = 0.001; 
betaD = 0.001;
betaH = 0.001;
beta = 0.001;

%%YAP/TAZ model 
power = 0.5;
stiff = E';
dFak=(ksfkdf.*(((LD.*stiff).^power)./(C.^power+(LD.*stiff).^power)).*(Fak_total-Fak) - Fak); 

dRhoA=(k_fkp.*(y.*Fak.^2+1).*(RhoA_total-RhoA)-k_dp.*RhoA);

dRock=(k_rp.*RhoA.*(Rock_total-Rock)-k_drock.*Rock);

dmDia=(k_mp.*RhoA.*(mDia_total-mDia)-k_dmDia.*mDia);

T = Fsmooth(smoothingparameter2,RockB1,Rock);

dMyo=(k_mr.*(e.*T+1).*(Myo_total-Myo)-k_dmy.*Myo); %Altered smooth funct

T = Fsmooth(smoothingparameter2,RockB2,Rock);

dLimk=(k_lr.*(tau.*T+1).*(Limk_total-Limk)-k_dl.*Limk); %new smooth

dCofilin=k_turnover.*(Cofilin_total-Cofilin)-k_cr.*(1-k_ll*LATS0).*Limk.^2.*Cofilin;

T = Fsmooth(smoothingparameter1,mdiaB,mDia);

dFcyto=(k_ra.*(alfa.*T+1).*(Fcyto_total-Fcyto)-k_dep.*Fcyto-k_fc1.*Cofilin.*Fcyto); %New smooth

dYaptaz= (((k_CN+k_cy.*Fcyto.*Myo).*(Yaptaz_total-Yaptaz)-(k_NC+k_ly*LATSP).*Yaptaz));  %with factin

dFstr =dFcyto.*dMyo; 

dmal=((k_cnm./((Fcyto_total-Fcyto).^2)).*(mal_total-mal)-k_ncm.*mal);
%%

%%Venkatraman model
Dext = 0*(t<3*8640) + prods*(t>3*8640);
V= V0 + kpf*V0.*F.^2;

dVR   = -k1*V.*VR + k_1*v_VR - deg*VR + kprod1VR - kinh*VR.*HE.^2; %VEGF Receptor
dv_VR = k1*V.*VR - k_1*v_VR - deg*v_VR; %VEGF-VEGFReceptor bound

XX = (lambda + ((1-lambda)./(1+(Yaptaz./Yap0).^nn)));

YY = -0.6121.*Yaptaz + 1.0578; 

k2=k2.*YY;
k2e=k2; %No SC interactions, so k2 is equal for all cases
dDL = ((betaD + theta*v_VR.^2./(1+v_VR.^2))/2).*XX - degD*DL - k2.*DL.*[NR(end);NR(1:end-1)] + k_2*[D_NR(end);D_NR(1:end-1)]...
    +Diff*((DL+DR)/2-DL) ;%Delta left side cell

dDR = ((betaD + theta*v_VR.^2./(1+v_VR.^2))/2).*XX - degD*DR - k2.*DR.*[NL(2:end);NL(1)] + k_2*[D_NL(2:end);D_NL(1)]...
    +Diff*((DL+DR)/2-DR) ;%Delta right side cell

dNL = -k2.*NL.*[DR(end);DR(1:end-1)] + k_2*D_NL - degN*NL + kprodN/2 ...
    +Diff*((NL + NR)/2 - NL) - k2e.*NL.*Dext + k_2*Dext_NL; %Notch left side cell

dNR = -k2.*NR.*[DL(2:end);DL(1)] + k_2*D_NR - degN*NR + kprodN/2 ...
    +Diff*((NL + NR)/2 - NR) - k2e.*NR.*Dext + k_2*Dext_NR; %Notch right side cell

dDext_NL = k2e.*NL.*Dext - k_2*Dext_NL - degDN*Dext_NL - kcat1*Dext_NL; %D.N with external Delta - left
dDext_NR = k2e.*NR.*Dext - k_2*Dext_NR - degDN*Dext_NR - kcat1*Dext_NR; %D.N with external Delta - right 

dD_NL = k2.*NL.*[DR(end);DR(1:end-1)] - k_2*D_NL - degDN*D_NL - kcat1*D_NL; %D.N with Delta of neighbours - left side 

dD_NR = k2.*NR.*[DL(2:end);DL(1)] - k_2*D_NR - degDN*D_NR - kcat1*D_NR; %D.N with Delta of neighbours - right side 

dI  = kcat1*(D_NL+D_NR + Dext_NL + Dext_NR) - degI*I; % NICD 

dHE = betaH + theta*I.^2./(1+I.^2) - degHE*HE;  %HE 

dF  = beta + konfa*v_VR.^2 - kturnFA*F; %Filopodia 
%%

dy=[dFak;dRhoA;dRock;dmDia;dMyo;dLimk;dCofilin;dFcyto;dYaptaz;dmal;dFstr;dVR;dv_VR;dDL;dDR;dNL;dNR;dD_NL;dD_NR;dI;dHE;dF;dDext_NL;dDext_NR];%;DGG];

end


