nameslist=["Time_all_20.mat","Time_all_50.mat","Time_all_100.mat","Time_all_200.mat"]; %List of different conditions that will be plotted
Titles=["20 um","50 um","100 um","200 um"]; %Titles that will be provided with all plots
for i = 1:length(nameslist) %loop through all 4 plots
    load(nameslist(i)) %load the data for the respective plot
    figg=figure(); 

    mdnvaluest(mdnvaluest==1)=0; %set not-patterned cases to 0
    timee=mdnvaluest; 
    timee=flip(timee,1);

    ax = axes(figg);
    imagesc(ax,timee);
    Rsize = size(timee);

    set(ax,'xtick', 1:Rsize(2), 'xticklabel',['0.5 '; '1.5 '; '2.5 '; '3.7 '; '4.7 '; '5.6 '; '6.6 '; '7.6 '; '8.7 '; '9.8 '; '11.2'; '12.7'; '14.6'; '17  '; '20.1'; '24.2'; '30  '; '38.5'; '52.6'; '70  '; '79.5'; '143 '; '380 '; '400 '],...
         'ytick', 1:Rsize(1), 'yticklabel' ,['400 ' ;'380 ' ;'143 '; '79.5'; '70  '; '52.6'; '38.5'; '30  '; '24.2'; '20.1'; '17  '; '14.6'; '12.7'; '11.2'; '9.8 '; '8.7 '; '7.6 '; '6.6 '; '5.6 '; '4.7 '; '3.7 '; '2.5 '; '1.5 '; '0.5 '])
    %Set the axes to visualize the different stiffnesses that we ran for
    %the simulations

    hold(ax,'on') %Create the figure 
    mask= timee==0;
    [X,Y]=meshgrid(1:Rsize(2), 1:Rsize(1));
    plot(ax, X(mask), Y(mask), 'kx', 'MarkerSize', 5)
    [grad,im]=colorGradient([204,102,119]/255,[136,204,238]/255,128); 
    colormap(ax, grad)
    colorbar(ax)
    annotation('textarrow',[1,1],[0.5,0.5],'string','Patterning rate', ...
          'FontSize', 12,...
          'HeadStyle','none','LineStyle','none',...
          'HorizontalAlignment','center','TextRotation',90);
    caxis(ax,[0,35])
    xlabel('Stiffness 1 [kPa]')
    ylabel('Stiffness 2 [kPa]')
    title(Titles(i));
end