function [valVars,fVals]=FitprD(D4,Stiff,lb,ub,x0,optno)


costFunction = @(x) MSE(x,D4, Stiff); %Calling the program that determines the difference between simulated response and data
options = optimoptions(@lsqnonlin,'Algorithm','trust-region-reflective','Display','iter','StepTolerance',1e-9,'MaxFunctionEvaluations',500);
%set the options for the least squares non linear fitting algorithm
%(lsqnonlin)
rng('shuffle');

for i=1:optno
    %set random starting values for all parameters to be fitted 
    x0(1)=rand;
    x0(2)=rand;
    x0(3)=rand*10; 
    
    %call on the fitting algorithm 
    [val,fval,exitflag]=lsqnonlin(costFunction,x0,lb,ub,options);
    %save the output in a list
    fVals(i,:)=fval;
    valVars(i,:)=val;
end



end