function mse = MSE(xfit,D4,stiff)

%%General parameters for the model 
Dll4_ext = 0; 

ncells=10; LD=1; E=1; c=7.5; threshold_rock_s=0.1; smoothing_range_s=0.2;

Fak_total_s=1; RhoA_total_s=1; Rock_total_s=1; mDia_total_s= 1; Myo_total_s= 1; Limk_total_s=1; Cofilin_total_s=1; Fcyto_total_s=1;
Yaptaz_total_s=1; mal_total_s=1; y_parameter_s=500;

Fak0=rand(1,ncells)*0; RhoA0=rand(1,ncells)*0; Rock0=rand(1,ncells)*0; mDia0=rand(1,ncells)*0; Myo0=rand(1,ncells)*0; Limk0=rand(1,ncells)*0; Cofilin0=rand(1,ncells)*0;
Fcyto0=rand(1,ncells)*0; Yaptaz0=rand(1,ncells)*0; mal0=rand(1,ncells)*0; Fstr0=rand(1,ncells)*0;
    
%Starting values for VEGF model 
VR0(1,1:ncells)= ones(1,ncells);  v_VR0(1,1:ncells)= rand(1,ncells)*0;
DL0(1,1:ncells)= rand(1,ncells)*0;  DR0(1,1:ncells)= rand(1,ncells)*0; 
NL0(1,1:ncells)= ones(1,ncells)*0;  NR0(1,1:ncells)= ones(1,ncells)*0; 
D_NL0(1,1:ncells)= rand(1,ncells)*0;  D_NR0(1,1:ncells)= rand(1,ncells)*0; 
I0(1,1:ncells)= rand(1,ncells)*0;  HE0(1,1:ncells)= rand(1,ncells)*0; 
F0(1,1:ncells)= rand(1,ncells)*0; 

V0(1,1:ncells) = ones(1,ncells)*0;%For the condition without VEGF
Dext_NL0 = rand(1,ncells)*0; Dext_NR0 = rand(1,ncells)*0;
    
prods = Dll4_ext;
    
input=[threshold_rock_s;smoothing_range_s;Fak_total_s;RhoA_total_s;Rock_total_s;mDia_total_s;Myo_total_s;Limk_total_s;Cofilin_total_s;Fcyto_total_s;LD;E;y_parameter_s;c;Yaptaz_total_s;mal_total_s];
y0=[Fak0,RhoA0,Rock0,mDia0,Myo0,Limk0,Cofilin0,Fcyto0,Yaptaz0,mal0,Fstr0, VR0,v_VR0,DL0,DR0,NL0,NR0,D_NL0,D_NR0,I0,HE0,F0,Dext_NL0,Dext_NR0];

    x=1;
    j=0;
    stiffnesrange=stiff;
    for mm = 1:length(stiffnesrange)
        E=stiffnesrange(mm);
        j=j+1;
        input(12)=E; 
        options=odeset('Reltol',1e-12,'AbsTol',1e-6);
        VEGF_ext = 0.03;%For the simulation with VEGF in the second 24 hours

        %Assign the trial values to the parameters to be fitted
        lambda = xfit(1);
        nn = xfit(3);
        Yap0 = xfit(2);

        [t,y]=ode15s(@differentationequations,[0 2*86400],y0,options,input,ncells,VEGF_ext,V0',lambda,nn,Yap0,prods);
        DGG(x:x*ncells,j)=((0.001 + 0.1*y(end,12*ncells+1:13*ncells).^2./(1+y(end,12*ncells+1:13*ncells).^2))/2).*(lambda+((1-lambda)./((1+(y(end,8*ncells+1:9*ncells))./Yap0).^nn)));
    end

    %Determine the difference between the simulated response (with
    %parameters to be fitted) and the data. 
D4sim = mean(DGG); 
for ii=2:length(D4sim)
    D4sim(ii)=D4sim(ii)/D4sim(1);
end
D4sim(1)=1;

mse = D4sim' - D4;
    
end