function mse = MSE(xfit,HEout,stiff)

%%General parameters for the model 
Dll4_ext = 0.1*2; %External DLL4 coating required for the fit 

ncells=1; LD=1; E=1; c=7.5; threshold_rock_s=0.1; smoothing_range_s=0.2;

Fak_total_s=1; RhoA_total_s=1; Rock_total_s=1; mDia_total_s= 1; Myo_total_s= 1; Limk_total_s=1; Cofilin_total_s=1; Fcyto_total_s=1;
Yaptaz_total_s=1; mal_total_s=1; y_parameter_s=500;

Fak0=rand(1,ncells)*0; RhoA0=rand(1,ncells)*0; Rock0=rand(1,ncells)*0; mDia0=rand(1,ncells)*0; Myo0=rand(1,ncells)*0; Limk0=rand(1,ncells)*0; Cofilin0=rand(1,ncells)*0;
Fcyto0=rand(1,ncells)*0; Yaptaz0=rand(1,ncells)*0; mal0=rand(1,ncells)*0; Fstr0=rand(1,ncells)*0;
    
%Starting values for VEGF model 
VR0(1,1:ncells)= ones(1,ncells) + rand(1,ncells)*10^(-8);  v_VR0(1,1:ncells)= rand(1,ncells)*0;
DL0(1,1:ncells)= rand(1,ncells)*0;  DR0(1,1:ncells)= rand(1,ncells)*0; 
NL0(1,1:ncells)= ones(1,ncells)*0;  NR0(1,1:ncells)= ones(1,ncells)*0; 
D_NL0(1,1:ncells)= rand(1,ncells)*0;  D_NR0(1,1:ncells)= rand(1,ncells)*0; 
I0(1,1:ncells)= rand(1,ncells)*0;  HE0(1,1:ncells)= rand(1,ncells)*0; 
F0(1,1:ncells)= rand(1,ncells)*0; 

V0(1,1:ncells) = ones(1,ncells)*0;
Dext_NL0 = rand(1,ncells)*0; Dext_NR0 = rand(1,ncells)*0;
    
prods = Dll4_ext;
    
input=[threshold_rock_s;smoothing_range_s;Fak_total_s;RhoA_total_s;Rock_total_s;mDia_total_s;Myo_total_s;Limk_total_s;Cofilin_total_s;Fcyto_total_s;LD;E;y_parameter_s;c;Yaptaz_total_s;mal_total_s];
y0=[Fak0,RhoA0,Rock0,mDia0,Myo0,Limk0,Cofilin0,Fcyto0,Yaptaz0,mal0,Fstr0, VR0,v_VR0,DL0,DR0,NL0,NR0,D_NL0,D_NR0,I0,HE0,F0,Dext_NL0,Dext_NR0];

    x=1;
    j=0;
    stiffnesrange=stiff;
    %all_HE = zeros(ncells,length(stiffnesrange));
    HH = zeros(ncells,length(stiffnesrange));
    lambda = 0.1; nn = 6.5; Yap0 = 0.47; 
    
    for mm = 1:length(stiffnesrange)
        E=stiffnesrange(mm);
        j=j+1;
        input(12)=E; 
        options=odeset('Reltol',1e-12,'AbsTol',1e-6, 'MaxStep', 100);
        VEGF_ext = 0.03/10;%Little amount of VEGF
        lambdaLF = xfit(1);%For this fit, this represents 'b'
        nnLF = xfit(2);%For this fit, this represents 'a' and is multiplied with -1 to obtain the inhibitory behavior (in differentiationequations_SC)

        [t,y]=ode15s(@differentationequations_SC,[0 2*86400],y0,options,input,ncells,VEGF_ext,V0',lambda,nn,Yap0,prods,lambdaLF,nnLF);
        HH(x:x*ncells,j)=mean(((0.001 + 0.1*y(end,19*ncells+1:20*ncells).^2./(1+y(end,19*ncells+1:20*ncells).^2))));

    end

%Determine difference between simulated and experimental data
HEsim = HH./0.001;

mse = HEsim' - HEout;
    
end