clearvars
%close all

rangestiff=[1.5, 9.8, 17, 400];
nameslist=["1.5 kPa","9.8 kPa","17 kPa","400 kPa"];
eff_lfng = 1; %Effect of YAP/TAZ on Lfng, 0 = no effect, 1 = YAP/TAZ inhibits Lfng
ncells = 10;
lambda = 0.1; %Effect of YAP/TAZ on Dll4, set lambda to 1 for no effect
nn = 6.5; Yap0 = 0.47; 
k = 4; kk = 0;

for ii=1:length(rangestiff)
    k = k+1; kk=kk+1;

    stiff=rangestiff(ii);
    [t1, y, tip, stalk, ttt, avgtime_to_pattern, time_to_pattern1,ntip] = RowCells2(stiff,eff_lfng,ncells,lambda,nn,Yap0);
    
    plotnumber = 21; plotnumber3 = 19; plotnumber4 = 15; plotnumber4b = 16;
    tini = 0; start = find(t1>tini);
    
    Filopodia = zeros(ncells, length(ttt));
    DLLl = zeros(ncells, length(ttt));
    NICDd = zeros(ncells, length(ttt));
    Notchh = zeros(ncells, length(ttt));
    
    for cellnum = 1:ncells
          cell1 = fit(t1(start(1):end),y(start(1):end,plotnumber*ncells+cellnum),'smoothingspline');
          Filopodia(cellnum,:) = cell1(ttt);
          cell2=fit(t1(start(1):end),((0.001 + 0.1*y(start(1):end,12*ncells+cellnum).^2./(1+y(start(1):end,12*ncells+cellnum).^2))/2).*(lambda+((1-lambda)./((1+(y(start(1):end,8*ncells+cellnum))./Yap0).^nn))), 'smoothingspline');
          DLLl(cellnum,:) = cell2(ttt);
          cell3 = fit(t1(start(1):end),y(start(1):end,plotnumber3*ncells+cellnum),'smoothingspline');
          NICDd(cellnum,:) = cell3(ttt);
          cell4 = fit(t1(start(1):end),y(start(1):end,plotnumber4*ncells+cellnum)+y(start(1):end,plotnumber4b*ncells+cellnum),'smoothingspline');
          Notchh(cellnum,:) = cell4(ttt);
    end
    
    [grad,im]=colorGradient([100,100,180]/255,[80,180,80]/255,128);

    
    loca=find(ttt>=0);
    tt=ttt(loca(1):end);
    Filopodiaa=Filopodia(loca(1):end,:);

    tt = tt-tini;
    i = 1;
    while i <= length(tt)
        if mod(i,length(tt)/2) ~= 0
            CustomYLabels(i) = " ";
        else
            CustomYLabels(i) = string(round(tt(i)/3600));
        end
        i=i+1;
    end
    
    figure(2),subplot(2,4,kk), prova = colormap(grad); 
    DLLl = DLLl';
    h = heatmap(DLLl);
    clim([0 3.5*10^-4]);
    h.GridVisible = 'off';
    h.NodeChildren(3).YDir='normal';   
    tt = tt-tini;
    
    h.YDisplayLabels = CustomYLabels;
    h.Colormap = prova;
    ylabel('Simulation time [h]')
    xlabel('Cell index')
    
    annotation('textarrow',[1,1],[0.5,0.5],'string','DLL4 gene production', ...
          'FontSize', 12,...
          'HeadStyle','none','LineStyle','none',...
          'HorizontalAlignment','center','TextRotation',90);
    title(nameslist(ii))
    set(h, 'Fontsize',12)
    i = 1;
    while i <= length(tt)
        if mod(i,length(tt)/2) ~= 0
            CustomYLabels(i) = " ";
        else
            CustomYLabels(i) = string(round(tt(i)/3600));
        end
        i=i+1;
    end
    
    figure(2),subplot(2,4,k), prova = colormap(grad); 
    NICDd=NICDd';
    h = heatmap(NICDd);
    clim([0 0.025])
    h.GridVisible = 'off';
    h.NodeChildren(3).YDir='normal';   
    tt = tt-tini;
    
    h.YDisplayLabels = CustomYLabels;
    h.Colormap = prova;
    ylabel('Simulation time [h]')
    xlabel('Cell index')
    
    annotation('textarrow',[1,1],[0.5,0.5],'string','NICD', ...
          'FontSize', 12,...
          'HeadStyle','none','LineStyle','none',...
          'HorizontalAlignment','center','TextRotation',90);
    title(nameslist(ii))
    set(h, 'Fontsize',12)

end



